﻿Imports Microsoft.Win32



Public Class Form1
    Private fInit As Boolean = False
    Private fRepeat As Boolean = False
    Private fDataReady As Boolean = False
    Dim iRecLength As Integer
    Dim iVoltDiv As Integer()
    Dim dbWaveData As Double()
    Dim iProbe As Integer()


    Private Sub bnInit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnInit.Click
        If (DSOSDK_Class.uDsoSDKInit() > 0) Then
            EnableAllCtrl(True, False)
            fInit = True
        Else
            MessageBox.Show(Me, "Initial Error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        'Hardware probe setting = 10x
        ReDim iProbe(2)
        iProbe(0) = 10
        iProbe(1) = 10
    End Sub


    Private Sub bnShutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnShutdown.Click
        If (DSOSDK_Class.uDsoSDKShutdown()) Then
            EnableAllCtrl(False, False)
        Else
            MessageBox.Show(Me, "Shutdown Error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

    End Sub

    'Shutdown DSO when exit the program
    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If (fInit) Then
            DSOSDK_Class.uDsoSDKShutdown()
        End If
    End Sub

    Private Sub EnableAllCtrl(ByVal fEnable As Boolean, ByVal fCapturing As Boolean)
        If (fCapturing) Then
            bnInit.Enabled = False
            bnRCapture.Enabled = False
            bnSCapture.Enabled = False
            bnShutdown.Enabled = False
            bnStop.Enabled = True
        Else
            bnInit.Enabled = (fEnable = False)
            bnRCapture.Enabled = fEnable
            bnSCapture.Enabled = fEnable
            bnShutdown.Enabled = fEnable
            bnStop.Enabled = False
        End If

    End Sub


    'Read Setting INI file
    Private Sub bnReadINI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnReadINI.Click
        If (DSOSDK_Class.uDsoSDKReadIniFile(edIniDirectory.Text) = False) Then
            MessageBox.Show(Me, "Ini Read Error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    'Single shot capture
    Private Sub bnSCapture_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnSCapture.Click
        If (DSOSDK_Class.uDsoSDKCaptureEx()) Then
            fRepeat = False
            Timer1.Start()
            EnableAllCtrl(False, True)
        Else
            MessageBox.Show(Me, "Capture Start Error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    'Repeat Capture
    Private Sub bnRCapture_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRCapture.Click
        If (DSOSDK_Class.uDsoSDKCaptureEx()) Then
            fRepeat = True
            Timer1.Start()
            EnableAllCtrl(False, True)
        Else
            MessageBox.Show(Me, "Capture Start Error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    'Stop Capture
    Private Sub bnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnStop.Click
        If (DSOSDK_Class.uDsoSDKStop()) Then
            fRepeat = False
            Timer1.Stop()
            EnableAllCtrl(True, False)
        Else
            MessageBox.Show(Me, "Capture Stop Error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If (DSOSDK_Class.uDsoSDKDataReady()) Then
            Timer1.Stop()
            GetData()
            If (fRepeat) Then
                If (DSOSDK_Class.uDsoSDKCaptureEx()) Then
                    Timer1.Start()
                Else
                    MessageBox.Show(Me, "Capture Start Error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                EnableAllCtrl(True, False)
            End If
        End If
    End Sub


    Private Sub GetData()
        Dim iDev As Integer = 0
        DSOSDK_Class.uDsoSDKGetRecordLength(iRecLength)
        ReDim dbWaveData(iRecLength * 2)
        ReDim iVoltDiv(2)

        'Read Waveform Data into double array (unit : uV)
        If (DSOSDK_Class.uDsoSDKReadDbl_uv(iDev, 0, dbWaveData, iProbe)) Then
            fDataReady = True
            'Read the Volt Div Setting used in previous capture
            DSOSDK_Class.uDsoSDKGetVoltDiv(0, iVoltDiv(0))
            DSOSDK_Class.uDsoSDKGetVoltDiv(1, iVoltDiv(1))
            Me.Invalidate()
        End If

    End Sub


    'Draw waveform
    Private Sub Form1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        'In this sample, the Volt Division and Time Division are both 10 divisions
        Dim DivNumber As Integer = 10
        Dim rcCanvas As System.Drawing.Rectangle
        Dim ptCenter As System.Drawing.Point
        Dim ptWave As System.Drawing.Point()
        Dim iChRecOffset As Integer
        Dim dbTmp As Double
        Dim dashValues As Single() = {5, 5, 5, 5}
        Dim gridPen As New System.Drawing.Pen(System.Drawing.Color.Gray, 1)
        gridPen.DashPattern = dashValues

        rcCanvas = Me.RectangleToClient(picWaveform.RectangleToScreen(picWaveform.ClientRectangle))

        ptCenter.X = (rcCanvas.Left + rcCanvas.Right) / 2
        ptCenter.Y = (rcCanvas.Top + rcCanvas.Bottom) / 2
        e.Graphics.DrawRectangle(Pens.Black, rcCanvas)
        e.Graphics.DrawLine(Pens.DarkGray, ptCenter.X, rcCanvas.Top, ptCenter.X, rcCanvas.Bottom)
        e.Graphics.DrawLine(Pens.DarkGray, rcCanvas.Left, ptCenter.Y, rcCanvas.Right, ptCenter.Y)

        For i As Integer = 0 To DivNumber
            Dim iX As Integer = rcCanvas.X + rcCanvas.Width / DivNumber * i
            Dim iY As Integer = rcCanvas.Y + rcCanvas.Height / DivNumber * i
            e.Graphics.DrawLine(gridPen, rcCanvas.Left, iY, rcCanvas.Right, iY)
            e.Graphics.DrawLine(gridPen, iX, rcCanvas.Top, iX, rcCanvas.Bottom)
        Next


        ReDim ptWave(iRecLength)
        iChRecOffset = iRecLength
        If (fDataReady) Then    ' Show when waveform data has beed captured
            For iCh As Integer = 0 To 1
                For i As Integer = 0 To iRecLength
                    'Draw Waveform, and set the ground display position at the center of the rcCanvas
                    dbTmp = Convert.ToDouble(i) / Convert.ToDouble(iRecLength) * rcCanvas.Width + rcCanvas.Left
                    ptWave(i).X = dbTmp
                    ptWave(i).Y = ptCenter.Y - dbWaveData(i + iChRecOffset * iCh) / iVoltDiv(iCh) / DivNumber / 2 / iProbe(iCh) * rcCanvas.Height / 2
                Next
                If iCh Then
                    e.Graphics.DrawLines(Pens.Cyan, ptWave)
                Else
                    e.Graphics.DrawLines(Pens.Yellow, ptWave)
                End If
            Next
        End If

    End Sub
End Class
